#ifndef _COMMANDLINE_H_LOADED
#define _COMMANDLINE_H_LOADED

#include <time.h>
#include <qstring.h>

enum ParameterResultType
{
   ParameterType_Empty,
   ParameterType_Integer,
   ParameterType_String,
   ParameterType_Time,
   ParameterType_Bool
} ;

class CommandLineParameter
{
public:
   CommandLineParameter(int argc, char *argv[]);
   ~CommandLineParameter();

   int m_i_OutputLevel;
   int m_i_OutputLevelMaster;

   QString m_qs_OutputDevice;
   int     m_i_OutputDevice;

   QString m_qs_SoundDevice;
   QString m_qs_MixerDevice;

   QString m_qs_ServerAddress;
   int     m_i_ServerPort;

   bool m_b_ParseOK;  
   bool m_b_TestMode;

   int ParseParameter(int argc, char *argv[]);
   int ParseASingleParameter( char *cp_Parameter);

   bool CheckParameter(QString qs_Parameter,
                            QString qs_StartChars,
                            ParameterResultType e_ResultType,
                            void *p_Result);

   void ShowError(QString qs_Command,
                  QString qs_RealParameter,
                  ParameterResultType e_ResultType
                 );
   bool CheckValidParameters();

}; // CommandLineParameter

#endif  // _COMMANDLINE_H_LOADED






