//
#ifndef _HDCLIENT_H_LOADED
#define _HDCLIENT_H_LOADED


#include <stdio.h>
#include <unistd.h>
#include <pthread.h>
#include <semaphore.h>

#include <qwidget.h>

#include <qapplication.h>
#include <qmainwindow.h>

#include <qstatusbar.h>
#include <qtoolbar.h>
#include <qscrollbar.h>
#include <qlabel.h>
#include <qslider.h>
#include <qcheckbox.h>
#include <qgroupbox.h>
#include <qradiobutton.h>

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include "saveblock.h"
#include "audioplayer.h"
#include "maindialog.h"
#include "mixer.h"
#include "hdclient_basis.h"


extern "C"
{
#include "lame.h"
}


class HdClient 
{
public:
   HdClient(QWidget *parent,
                  QApplication *mainApplication);
   
   ~HdClient();


   SaveBlockArray       *pc_SaveBlocks;
   AudioPlayer          *pc_AudioPlayer;

   pthread_attr_t SocketAttribut;
   pthread_t      p_SocketThread;

   pthread_attr_t PlayerAttribut;
   pthread_t      p_PlayerThread;

   static void * SocketThreadCB(void * p_Pointer);
   void * SocketThread();
  
   static void * PlayerThreadCB(void * p_Pointer);
   void * PlayerThread();

   pthread_cond_t p_PlayerCondition;
   pthread_mutex_t p_PlayerMutex;
   struct timespec t_PlayerTimespec;

   int ClientSocket;

   struct sockaddr_in ClientAddress;
   struct sockaddr_in ServerAddress;
   unsigned char uc_ReceiveBuffer[0x10000];
   short int us_LeftPCM[0x10000];
   short int us_RightPCM[0x10000];
   mp3data_struct MP3Data;

   public:  		//-----------------public functions 

   void SetMainDialog(MainDialog *pc_MainDialog);

   void Beenden();

   void DoStart();
   void DoStop();
   void WaitForTermination();
   void ReinitParameter();

   void DoSliderValueChanged(int);
   void DoMasterSliderValueChanged(int);

   void InitializeDisplay();
   void SetOutputMixer();


public:			// --------------- public variables
   MainDialog           *m_pc_MainDialog;
   MixerDevice          *m_pc_Mixer;

   MainDialog           *m_p_MainDialog;

   QString               m_qs_SoundDevice;
   QString               m_qs_MixerDevice;

   int                   m_i_MixerOutputDevice;
   int                   m_i_OutputLevel;
   int                   m_i_OutputLevelMaster;

   QString               m_qs_IPAddress;
   int                   m_i_IPPort;

   ProgramState          m_ProgramState;

   BasisDatenType       *m_BasicData;


private:

   void CloseConnection();

   in_addr_t GetAddress (QString qs_ComputerName);

}; // class hdrecord

#endif // _HDCLIENT_H_LOADED



















