//
#ifndef _MAINDIALOG_H_LOADED
#define _MAINDIALOG_H_LOADED


#include <stdio.h>
#include <unistd.h>

#include <qwidget.h>

#include <qapplication.h>
#include <qmainwindow.h>

#include <qstatusbar.h>
#include <qtoolbar.h>
#include <qscrollbar.h>
#include <qlabel.h>
#include <qslider.h>
#include <qcheckbox.h>
#include <qgroupbox.h>
#include <qradiobutton.h>
#include <qpushbutton.h>

#include "samplearea.h"
#include "basedef.h"


class HdClient;

extern "C"
{
#include "lame.h"
}


class MainDialog : public QMainWindow
{
  Q_OBJECT
public:
   MainDialog(QWidget *parent,
                  QApplication *mainApplication,
                  HdClient *pc_Player);
   
   ~MainDialog();
  
public slots: 
   void DoAboutBox();
   void DoSliderValueChanged(int);
   void DoMasterSliderValueChanged(int);
   void DoConnectButton();
   void DoStopButton();
   void DoSettingsBox();
   void Beenden();

public:
   void SetOutputLevel(int i_SampleLevel);
   void SetOutputLevelMaster(int i_SampleLevelMaster);
   void SetSensitivity(ProgramState c_ProgramState);
   void SetStatusLabel(QString qs_StatusString);
   void FlushDisplay();
   void TurnGraphics();


public:
   QApplication   *m_pc_MainApplication;
   HdClient       *m_pc_Player;

   //------ menubar section
   QPopupMenu  *m_FileMenu;


   //-------- sample level section 
   QSlider     *OutputLevelSlider;
   QLabel      *OutputLevelLabel;
   QSlider     *OutputLevelMasterSlider;
   QLabel      *OutputLevelMasterLabel;


   //------- main buttons
   QPushButton *ConnectButton;
   QPushButton *StopButton;

   //-------- status line at the lower end
   QLabel      *StatusLabel;

   SampleArea  *m_pc_SampleArea;


protected:
   void closeEvent(QCloseEvent *);


} ; // class MainDialog

#endif






