#ifndef _H_SAMPLE_AREA_H
#define _H_SAMPLE_AREA_H

#include <qapplication.h>

#include <qwidget.h>
#include <qimage.h>
#include <qfont.h>
#include <qcolor.h>
#include <qbrush.h>

// number of values in the sample area
#define SAMPLE_AREA_VALUES 256

class SampleArea : public QWidget
{
   Q_OBJECT

   public:
   
   SampleArea(QWidget *parent);
   ~SampleArea();
   
   void Initialize();
   void SetNextState();

   public:
      void  paintEvent(QPaintEvent *theEvent);
      void  resizeEvent(QResizeEvent *theEvent);

   
   private:
      // dimension of this area
      int i_Width;
      int i_Height;
      
      // pre allocated brush and colors, for faster drawings
      QBrush   *pc_Brush;
      QColor   *pc_WhiteColor;
      QColor   *pc_BlackColor;
      
      int m_i_State;
   
};


#endif

